"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.iterateFormatted = iterateFormatted;
const ReactAsyncIterable_js_1 = require("../common/ReactAsyncIterable.js");
const asyncIterSyncMap_js_1 = require("../common/asyncIterSyncMap.js");
const isAsyncIter_js_1 = require("../common/isAsyncIter.js");
function iterateFormatted(source, formatFn) {
    if (!(0, isAsyncIter_js_1.isAsyncIter)(source)) {
        return formatFn(source, 0);
    }
    const sourcePrevSpecialInfo = source[ReactAsyncIterable_js_1.reactAsyncIterSpecialInfoSymbol];
    return {
        [Symbol.asyncIterator]: () => (0, asyncIterSyncMap_js_1.asyncIterSyncMap)(source, formatFn)[Symbol.asyncIterator](),
        ...(!sourcePrevSpecialInfo
            ? {
                value: !source.value
                    ? undefined
                    : {
                        current: formatFn(source.value.current, 0),
                    },
                [ReactAsyncIterable_js_1.reactAsyncIterSpecialInfoSymbol]: {
                    origSource: source,
                    formatFn,
                },
            }
            : {
                value: !source.value
                    ? undefined
                    : {
                        current: (() => {
                            const prevMapResult = sourcePrevSpecialInfo.formatFn(source.value.current, 0);
                            return formatFn(prevMapResult, 0);
                        })(),
                    },
                [ReactAsyncIterable_js_1.reactAsyncIterSpecialInfoSymbol]: {
                    origSource: sourcePrevSpecialInfo.origSource,
                    formatFn: (value, i) => {
                        const prevMapResult = sourcePrevSpecialInfo.formatFn(value, i);
                        return formatFn(prevMapResult, i);
                    },
                },
            }),
    };
}
//# sourceMappingURL=index.js.map