import { reactAsyncIterSpecialInfoSymbol, } from '../common/ReactAsyncIterable.js';
import { asyncIterSyncMap } from '../common/asyncIterSyncMap.js';
import { isAsyncIter } from '../common/isAsyncIter.js';
export { iterateFormatted };
function iterateFormatted(source, formatFn) {
    if (!isAsyncIter(source)) {
        return formatFn(source, 0);
    }
    const sourcePrevSpecialInfo = source[reactAsyncIterSpecialInfoSymbol];
    return {
        [Symbol.asyncIterator]: () => asyncIterSyncMap(source, formatFn)[Symbol.asyncIterator](),
        ...(!sourcePrevSpecialInfo
            ? {
                value: !source.value
                    ? undefined
                    : {
                        current: formatFn(source.value.current, 0),
                    },
                [reactAsyncIterSpecialInfoSymbol]: {
                    origSource: source,
                    formatFn,
                },
            }
            : {
                value: !source.value
                    ? undefined
                    : {
                        current: (() => {
                            const prevMapResult = sourcePrevSpecialInfo.formatFn(source.value.current, 0);
                            return formatFn(prevMapResult, 0);
                        })(),
                    },
                [reactAsyncIterSpecialInfoSymbol]: {
                    origSource: sourcePrevSpecialInfo.origSource,
                    formatFn: (value, i) => {
                        const prevMapResult = sourcePrevSpecialInfo.formatFn(value, i);
                        return formatFn(prevMapResult, i);
                    },
                },
            }),
    };
}
//# sourceMappingURL=index.js.map